 /* COM_TST.CPP */
 /* pp p  p⠬: p */
 /* ()                     */
 /* : icc -Ss com_tst.c        */
 
 #include <io.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <signal.h>
 #include <conio.h>
 #include <time.h>
  #define INCL_KBD
  #define INCL_DOS
      #define INCL_DOSFILEMGR    /* File System values */
      #define INCL_DOSDEVIOCTL   /* DosDevIOCtl values */
  #include <os2.h>
 
 #define _F1    159
#define _UP    172
#define _DOWN  180
#define _LEFT  175
#define _RIGHT 177
#define _HOME  171
#define _END   179
#define _PGDOWN  0xb5

#define UP    72
#define DOWN  80
#define LEFT  75
#define RIGHT 77
#define FATAL_COLOR        "[1;31;40m"
#define WARNING_COLOR      "[1;33;40m"
#define IGNORING_COLOR     "[1;35;40m"
#define NORMAL_COLOR       "[0;37;40m"
#define DISABLE_COLOR      "[2;37;40m"
char LogFileName[]="comTerm.log";

int Comgets(HFILE Hcom,char *Buf,int buflen);
HFILE initComPort(int NComPort, int Bitrate, int fw);
int ComControl(int NComPort,int Bitrate, int fw, int logmode);
int SetDTRComPort(HFILE Hcom, int fw);
int  DosWriteIMM(HFILE Hcom,char str[2]);
ULONG MyExceptionHandler(PEXCEPTIONREPORTRECORD perrTrap);
FILE *fpLog = NULL; 
 
int main(int npar, char *par[])
{  int nport,Bitrate=9600, fw=0, logmode=0, rc;
    int i;
FILE *fp;    
    nport=2;
    printf("%sComTerm\nExit=Crtl+Break%s\n",WARNING_COLOR,NORMAL_COLOR);
    if(npar > 1)
    { if( !stricmp(par[1],"help") ||  (*par[1] == '-' && *(par[1]+1) == '?') )
      {  printf("Usage: comTerm Nport [Bitrate [log] [F=%%x]]]\n");   
         exit(0);
      }
      rc = sscanf(par[1],"%i",&nport);
      printf("Port=%i",nport); 
       if(npar > 2)
        { rc = sscanf(par[2],"%i",&Bitrate);
           printf(" Bitrate=%i",Bitrate); 
          if(npar > 3)
          {  
             if(!stricmp(par[3],"log")) logmode=1;
             else 
               if(*par[3] == 'F' && *(par[3]+1) == '=')
             {  
                rc = sscanf(par[3]+2,"%x",&fw);
                printf(" FW=%x\n",fw); 
             }
          }
          if(npar > 4)
          {
             if(*par[4] == 'F' && *(par[4]+1) == '=')
             {  
                rc = sscanf(par[4]+2,"%x",&fw);
                printf(" FW=%x\n",fw); 
             }
          }
       }   
    }  
    
    { 
        KBDINFO kbInfo;
        HKBD hKbd = 0;
        kbInfo.fsMask = KEYBOARD_BINARY_MODE;
        rc = KbdSetStatus(&kbInfo, hKbd);
        printf("rc=%x\n",rc);
    
//        printf("file name ?\n"); 
//        fflush(stdout);
//        gets(fname);
//        printf("fname=%s\n",fname); 
    }
    
    ComControl(nport,Bitrate,fw, logmode);
    return 0;
 } 
 
 /***********************/
 /* ⫠ p */
 int ComControl(int NComPort, int Bitrate, int fw, int logmode)
 {  int rc,X=0,Y=0,ZadX,Cpos,kon,t0,t1, isKey=0, hexmode=0;
    short int sts;
    KBDKEYINFO CharData;
    HKBD hKbd = 0;
    
/*    int Bitrate=9600; */
    int i;
    int nbytes,ComBuffSize;
    long int nbytesRead,nbytesWrite;
    int Nunit=0,inCache;
    HFILE Hcom;
    char str[520];
    
      sscanf(str,"%i",&NComPort);
      Hcom = initComPort(NComPort, Bitrate, fw);
      if(Hcom == NULL) return 0;
   {     
static   EXCEPTIONREGISTRATIONRECORD errRegister;
     APIRET           arReturn;
     int *pTest = NULL, id;
     errRegister.ExceptionHandler = (_ERR *)&MyExceptionHandler;
     arReturn = DosSetExceptionHandler(&errRegister);
     
     printf("DosSetExceptionHandler returns %ld\n",
          arReturn);
    }
    fpLog = fopen(LogFileName,"wb");
    if(fpLog)
    {  printf("Logfile=%s\n", LogFileName);
    }
    if(logmode)    
       printf("Log file write only mode\n");
  M0:
 
    nbytes =Comgets(Hcom,str,512);
 
    if(nbytes > 0)
     {  static int total=0, t0=0, t,t1, t10=0;  
        int needflush=0;    
        if(logmode)
        {
           if(total==0) t0 = clock();
           else
           {  t = clock()-t0;
              t1 = t/1000;
              if(t1!=t10)
              {  // printf("\r%sBytes/s=%.3f %i%s\n", 
                 //   WARNING_COLOR,((double)(total))/t1,nbytes,NORMAL_COLOR);
                 printf("%i bytes recived\n",total); 
                 t10 = t1;
              }
           }
           total += nbytes;
        }   
          str[nbytes+1] = 0;
          if(hexmode)
          {   if(!logmode)    
                    for(i=0; str[i]; i++)  printf("%3x ",str[i]); 
          } else {
             if(str[nbytes-1] == '\r') 
             {   str[nbytes] = '\n';
                 needflush++;
                 nbytes++;
             }     
          if(!logmode)    
                 printf("%s",str);
/*             
              for(i=0; str[i]; i++)  printf("%3x ",str[i]); 
            { int xx; 
              xx = '\n';
             printf("%x}\n",xx);
             }
*/             
          } 
          if(needflush)
          {   fflush(stdout);
              needflush = 0;
          }
          if(fpLog)
             fwrite(str,1, nbytes, fpLog);
     } 
 
    t0 = clock();
    
    for(;;)
    { isKey = 0;
      if(_kbhit())
      {   rc = _getch();
          if(_kbhit())
          {  rc = _getch();
            if(rc){ rc += 100; isKey = 1; }
          }
          if(isKey) printf("\n");
//          else      printf("%c",rc); 
//          if(rc == '\r')  printf("\n"); 
//          fflush(stdout);
        break;
       }
      t1 = clock();
      if(t1-t0 > 2)
      {  rc =0; break;
      } else { 
        KBDINFO kbInfo;
        HKBD hKbd = 0;
        kbInfo.fsMask = KEYBOARD_BINARY_MODE;
        rc = KbdSetStatus(&kbInfo, hKbd);
      
         DosSleep(1);
        kbInfo.fsMask = KEYBOARD_ASCII_MODE;
        rc = KbdSetStatus(&kbInfo, hKbd);
      }
    }

   if(!isKey)
   { 
        if(rc)
        {
           str[0]= rc;
           str[1]= 0;
           DosWrite(Hcom,str,1,&nbytesWrite);
//             DosWriteIMM(Hcom,str);
        }
   } else {
     switch(rc)
      {   case  _DOWN: 
          if(!logmode)     
          {   hexmode = 1;
              printf("HEXMODE ON\n"); 
          }    
            break;
          case _UP:
          if(!logmode)    
          {  printf("HEXMODE Off\n"); 
             hexmode = 0;
          }   
             break;
           case _PGDOWN:
         { FILE *fp;
           char fname[256];
           int flen, ch;

           printf("file name ?\n"); 
           fflush(stdout);
           gets(fname);
           fp = fopen(fname, "rb");
           if(fp == NULL)
           {  printf("Error open file %s\n",fname);
              break;
           }
           flen = _filelength (fileno(fp));
           for(i=0;i<flen;i++)
           {   rc =fread(&str,1,1,fp);
               if(rc != 1)
               {  printf("Error readind %s\n", fname);
                  break;
               }
               str[1]= 0;
               DosWrite(Hcom,str,1,&nbytesWrite);
           }
            printf("\aDone\n\n");
           fclose(fp);
         }
             break;
      }

   } 
 goto M0;
   return 0;
 } 

int  DosWriteIMM(HFILE Hcom,char str[2])
{
   int rc;
   char byteTrans = str[0];
   ULONG ulParmLen=1; 

     rc = DosDevIOCtl(
      Hcom,IOCTL_ASYNC,    /* Serial-device control      */
      ASYNC_TRANSMITIMM,   /* transmits byte immediate.    */

      (PULONG) &byteTrans ,
       1,
       &ulParmLen,       /* Length of parameter packet */
      NULL,      /* Data packet                */
      0,         /* Maximum size of data packet*/
      NULL);                 /* Length of data packet      */
printf("DosWrite rc=%x",rc);
     return 0;
}

//( Device Control Block Information data structure. 
//
//struct DCBINFO {
// USHORT   usWriteTimeout;         /*  Time period used for Write Timeout processing. */
// USHORT   usReadTimeout;          /*  Time period used for Read Timeout processing. */
// BYTE     fbCtlHndShake;          /*  HandShake Control flag. */
// BYTE     fbFlowReplace;          /*  Flow Control flag. */
// BYTE     fbTimeout;              /*  Timeout flag. */
// BYTE     bErrorReplacementChar;  /*  Error Replacement Character. */
// BYTE     bBreakReplacementChar;  /*  Break Replacement Character. */
// BYTE     bXONChar;               /*  Character XON. */
// BYTE     bXOFFChar;              /*  Character XOFF. */
//};

int SetDTRComPort(HFILE Hcom, int fw)
{
 
// DCBINFO;
// 
// typedef DCBINFO *PDCBINFO;
 int i,dl;
 struct _DCBINFO info;
 int rc;
 ULONG ulParmLen; 

     rc = DosDevIOCtl(
      Hcom,IOCTL_ASYNC,    /* Serial-device control      */
      ASYNC_GETDCBINFO, /* Get the COM status byte    */
      NULL, 0, NULL,       /* Length of parameter packet */
      (PULONG) &info,      /* Data packet                */
      sizeof(info),         /* Maximum size of data packet*/
      &dl);                 /* Length of data packet      */
/*
printf("usWriteTimeout = %i\n",(int)info.usWriteTimeout);
printf("usReadTimeout = %i\n",(int)info.usReadTimeout);
printf("fbCtlHndShake = %x\n",(int)info.fbCtlHndShake);
printf("fbFlowReplace = %x\n",(int)info.fbFlowReplace);
printf("fbTimeout = %x\n",(int)info.fbTimeout);
printf("bErrorReplacementChar = %x\n",(int)info.bErrorReplacementChar);
printf("bBreakReplacementChar = %x\n",(int)info.bBreakReplacementChar);
printf("bXONChar = %x\n",(int)info.bXONChar);
printf("bXOFFChar = %x\n",(int)info.bXOFFChar);
*/
 i = sizeof(info);
 ulParmLen = i;
// info.fbCtlHndShake = info.fbCtlHndShake & 0xef; /*  ࠥ  4 Enable output handshaking using DSR  */
//info.fbCtlHndShake &= 0xfc;
//info.fbCtlHndShake |= 0x1;

if(fw)
{  fw &= (~0x84);
   switch(fw&0x3)
   {  case 0: printf("DTR Control Disable\n"); break;
      case 1: printf("DTR Control Enable\n"); break;
      case 2: printf("DTR: Input handshaking\n"); break;
      case 3: printf("DTR: Invalid input. Results in a general failure error\n"); break;
   }
   if(fw&0x8) printf("Enable output handshaking using CTS\n");
   if(fw&0x10) printf("Enable output handshaking using DSR\n");
   if(fw&0x20) printf("Enable output handshaking using DCD\n");
   if(fw&0x40) printf("Enable output handshaking using DSR\n");
}
info.fbCtlHndShake = fw;

/*
   
  fbCtlHndShake (BYTE) 
     HandShake Control flag. 

     Has the following bits: 

       Bits 0-1 DTR Control mode.  Has the following: 
            Bit 1   Bit 0       Description 
              0       0          Disable 
              0       1          Enable 
              1       0          Input handshaking 
              1       1          Invalid input.  Results in a general failure error. 

       Bit 2    Reserved. Must be 0. 
       Bit 3    Enable output handshaking using CTS 
       Bit 4    Enable output handshaking using DSR 
       Bit 5    Enable output handshaking using DCD 
       Bit 6    Enable input sensitivity using DSR 
       Bit 7    Reserved. Must be 0. 
*/
     rc = DosDevIOCtl(
      Hcom,IOCTL_ASYNC,    /* Serial-device control      */
      ASYNC_SETDCBINFO, /* Get the COM status byte    */
      (PULONG) &info, 
      i, 
      &ulParmLen,       /* Length of parameter packet */
      NULL,      /* Data packet                */
      0,         /* Maximum size of data packet*/
      NULL);                 /* Length of data packet      */


  return 0;      
}
 
 /*******************************************/
 int Comgets(HFILE Hcom,char *Buf,int buflen)
 {   int rc,i,j,is,n, ns;
     int nbytes,ComBuffSize,nbytesRead,nbytesWrite;
     USHORT  buff[2];
     USHORT  buffOut[2];
     int sts;
     unsigned long int dl; 
    dl = 2;
/* */
//   printf("ComgetsIn\n"); fflush(stdout); 
     rc = DosDevIOCtl(
      Hcom,IOCTL_ASYNC,    /* Serial-device control      */
      ASYNC_GETCOMMSTATUS, /* Get the COM status byte    */
      NULL, 0, NULL,       /* Length of parameter packet */
      (PULONG) &buff[0],      /* Data packet                */
      1, /* sizeof(buff),*/        /* Maximum size of data packet*/
      &dl);                 /* Length of data packet      */

      sts = (int) buff[0];
/*  printf("Sts=%i, dl=%i\n",sts,dl);
//   printf("Comgets1\n"); fflush(stdout); 
*/
/*****************************/
//  nbytesRead = 0;
//   i = 1;
//     rc = DosDevIOCtl(
//      Hcom,IOCTL_ASYNC,    /* Serial-device control      */
//      ASYNC_GETOUTQUECOUNT, /* Get the COM status byte    */
//      NULL, 0, NULL,       /* Length of parameter packet */
//      (PULONG) &buffOut,      /* Data packet                */
//      sizeof(buffOut),        /* Maximum size of data packet*/
//      &i);                 /* Length of data packet      */
//
//     nbytes = (int) buff[0];

/*****************************/
   nbytesRead = 0;
   i = 1;
     rc = DosDevIOCtl(
      Hcom,IOCTL_ASYNC,    /* Serial-device control      */
      ASYNC_GETINQUECOUNT, /* Get the COM status byte    */
      NULL, 0, NULL,       /* Length of parameter packet */
      (PULONG) &buff,      /* Data packet                */
      sizeof(buff),        /* Maximum size of data packet*/
      &i);                 /* Length of data packet      */

     nbytes = (int) buff[0];
//printf("rc=%x,nbytes=%i,Ql=%i, L=%i, sts =%x",rc,nbytes,(int)buff[1],i,sts); 
//printf("Out=%i,%i\n",(int)buffOut[0],(int)buffOut[1]);
//if(nbytes )
//{
//printf("rc=%x,nbytes=%i",rc,nbytes); 
//fflush(stdout);
//}
     if(rc) return -1;
 
     if(nbytes)
     {  if(nbytes > buflen) nbytes = buflen;
         rc=DosRead(Hcom,Buf,nbytes,&nbytesRead);
         Buf[nbytesRead] = 0;
     } 
     return nbytesRead;
 } 
 
 
HFILE initComPort(int NComPort, int Bitrate, int fw)
{   char devName[10];
  HFILE  hf;          /* File handle for the device           */
  USHORT usBPS = 2400;/* Bit rate to set the COM port to      */
  ULONG  ulParmLen= 2;/* Maximum size of the parameter packet */
  ULONG  ulAction;    /* Action taken by DosOpen              */
  UCHAR  ucStatus;    /* The COM port status byte             */
  ULONG  ulStatusLen; /* Length of status (the data packet)   */
  UCHAR  Linectrl[3]; /* array for DataBits,Parity,StopBits   */
  APIRET rc;          /* Return code */
  struct
       {
        ULONG baud;
        BYTE frac;
        } baud = { Bitrate, 0 };
  ULONG baudSize=( sizeof( baud ) );
 
     usBPS = (USHORT) Bitrate;
 
     sprintf(devName,"COM%i",NComPort);
 
    rc = DosOpen(devName,
                 &hf,
                 &ulAction,
                 0,
                 FILE_NORMAL,
                 FILE_OPEN,
                 OPEN_ACCESS_READWRITE | 
                 OPEN_SHARE_DENYNONE|OPEN_FLAGS_SEQUENTIAL,
                (PEAOP2) NULL);
  if(rc)
  { fprintf(stderr, "Open of %s failed with rc=%i\n",devName,rc);
       exit(1);
  } else { 
      printf("Open of %s Ok\n",devName);
  }

#ifdef TrollUnderFromOak 
   rc = DosDevIOCtl(
     hf,                /* Device handle                  */
     IOCTL_ASYNC,       /* Serial-device control          */
     ASYNC_SETBAUDRATE, /* Sets bit rate                  */
     (PULONG) &usBPS,   /* Points at bit rate             */
     sizeof(usBPS),     /* Maximum size of parameter list */
     &ulParmLen,        /* Size of parameter packet       */
     NULL,              /* No data packet                 */
     0,                 /* Maximum size of data packet    */
     NULL);             /* Size of data packet            */
#endif 

  rc = DosDevIOCtl(hf, IOCTL_ASYNC, ASYNC_EXTSETBAUDRATE,
                      &baud, baudSize, &baudSize, 0, 0, 0 );

  if(rc)
  { fprintf(stderr, "DosDevIOCtl failed with rc=%i\n",rc);
         exit(1);
     } else { 
         printf("%s is set to %i bitrate\n",devName,Bitrate);
     } 
 
 /*
  Field         Length     C Datatype  
  
  Data Bits     BYTE       UCHAR        
  Parity        BYTE       UCHAR        
  Stop Bits     BYTE       UCHAR        
  
 */
 
      Linectrl[0] = 8; /* data bits  */
      Linectrl[1] = 0; /* parity - NO */
      Linectrl[2] = 0; /* Stop Bits - 1  */
 
    rc = DosDevIOCtl(
         hf,                /* Device handle                  */
         IOCTL_ASYNC,       /* Serial-device control          */
         ASYNC_SETLINECTRL, /* Sets line Characteristics      */
         (PULONG) &Linectrl,/* Points at bit rate             */
         3,                 /* Maximum size of parameter list */
         &ulParmLen,        /* Size of parameter packet       */
         NULL,              /* No data packet                 */
         0,                 /* Maximum size of data packet    */
         NULL);             /* Size of data packet            */
 
  if(rc)
  {   fprintf(stderr, "DosDevIOCtl ASYNC_SETLINECTRL"
                      "failed with rc=%i\n",rc);
      exit(1);
  } else { 
      printf("%s is set to %i data bits,"
             " %i parity, %i stopBits\n",
              devName,(int)Linectrl[0],
             (int)Linectrl[1],(int)Linectrl[2]);
  }
     SetDTRComPort(hf, fw);
     return hf;
 } 

ULONG MyExceptionHandler(PEXCEPTIONREPORTRECORD perrTrap)
{
   ULONG            ulReturn;
   APIRET           arReturn;
   PBYTE            pbTrap;
static int raz=0;
    static int single = 0;

    if(single)
        return XCPT_CONTINUE_SEARCH;

   ulReturn = XCPT_CONTINUE_SEARCH;
   raz++;
   printf("*-> Guard exception <-* %x flag %x,%x raz=%i\n",
             perrTrap->ExceptionNum, perrTrap->fHandlerFlags, perrTrap->ExceptionInfo[0], raz );

   if (perrTrap->ExceptionNum == XCPT_SIGNAL)
   {
       if (perrTrap->ExceptionInfo[0] == XCPT_SIGNAL_INTR)
       {    //   ulReturn = XCPT_CONTINUE_EXECUTION;
               printf("^C\n");
             //Ignore
            return XCPT_CONTINUE_EXECUTION;
       }        
       if(fpLog)
       {  fclose(fpLog);
          fpLog = NULL;
       }
       
  }

   single++;
  return  ulReturn;
}


